/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.bag.primitive;

import org.eclipse.collections.api.DoubleIterable;
import org.eclipse.collections.api.bag.MutableBag;
import org.eclipse.collections.api.block.function.primitive.DoubleToObjectFunction;
import org.eclipse.collections.api.block.predicate.primitive.DoublePredicate;
import org.eclipse.collections.api.collection.primitive.MutableDoubleCollection;

/**
 * This file was automatically generated from template file mutablePrimitiveBag.stg.
 *
 * @since 3.0.
 */
public interface MutableDoubleBag extends MutableDoubleCollection, DoubleBag
{
    void addOccurrences(double item, int occurrences);

    boolean removeOccurrences(double item, int occurrences);

    MutableDoubleBag select(DoublePredicate predicate);

    MutableDoubleBag reject(DoublePredicate predicate);

    <V> MutableBag<V> collect(DoubleToObjectFunction<? extends V> function);

    MutableDoubleBag with(double element);

    MutableDoubleBag without(double element);

    MutableDoubleBag withAll(DoubleIterable elements);

    MutableDoubleBag withoutAll(DoubleIterable elements);

    MutableDoubleBag asUnmodifiable();

    MutableDoubleBag asSynchronized();

    /**
     * Returns an immutable copy of this bag.
     */
    ImmutableDoubleBag toImmutable();
}
