/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.bag.primitive;

import org.eclipse.collections.api.FloatIterable;
import org.eclipse.collections.api.bag.MutableBag;
import org.eclipse.collections.api.block.function.primitive.FloatToObjectFunction;
import org.eclipse.collections.api.block.predicate.primitive.FloatPredicate;
import org.eclipse.collections.api.collection.primitive.MutableFloatCollection;

/**
 * This file was automatically generated from template file mutablePrimitiveBag.stg.
 *
 * @since 3.0.
 */
public interface MutableFloatBag extends MutableFloatCollection, FloatBag
{
    void addOccurrences(float item, int occurrences);

    boolean removeOccurrences(float item, int occurrences);

    MutableFloatBag select(FloatPredicate predicate);

    MutableFloatBag reject(FloatPredicate predicate);

    <V> MutableBag<V> collect(FloatToObjectFunction<? extends V> function);

    MutableFloatBag with(float element);

    MutableFloatBag without(float element);

    MutableFloatBag withAll(FloatIterable elements);

    MutableFloatBag withoutAll(FloatIterable elements);

    MutableFloatBag asUnmodifiable();

    MutableFloatBag asSynchronized();

    /**
     * Returns an immutable copy of this bag.
     */
    ImmutableFloatBag toImmutable();
}
