/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.collection.primitive;

import java.util.Collection;

import org.eclipse.collections.api.FloatIterable;
import org.eclipse.collections.api.block.function.primitive.FloatToObjectFunction;
import org.eclipse.collections.api.block.predicate.primitive.FloatPredicate;
import org.eclipse.collections.api.iterator.MutableFloatIterator;
import org.eclipse.collections.api.collection.MutableCollection;

/**
 * This file was automatically generated from template file mutablePrimitiveCollection.stg.
 *
 * @since 3.0.
 */
public interface MutableFloatCollection extends FloatIterable
{
    MutableFloatIterator floatIterator();

    boolean add(float element);

    boolean addAll(float... source);

    boolean addAll(FloatIterable source);

    boolean remove(float value);

    boolean removeAll(FloatIterable source);

    boolean removeAll(float... source);

    /**
     * @see Collection#retainAll(Collection)
     * @since 5.0
     */
    boolean retainAll(FloatIterable elements);

    /**
     * @see Collection#retainAll(Collection)
     * @since 5.0
     */
    boolean retainAll(float... source);

    void clear();

    MutableFloatCollection select(FloatPredicate predicate);

    MutableFloatCollection reject(FloatPredicate predicate);

    <V> MutableCollection<V> collect(FloatToObjectFunction<? extends V> function);

    MutableFloatCollection with(float element);

    MutableFloatCollection without(float element);

    MutableFloatCollection withAll(FloatIterable elements);

    MutableFloatCollection withoutAll(FloatIterable elements);

    MutableFloatCollection asUnmodifiable();

    MutableFloatCollection asSynchronized();

    ImmutableFloatCollection toImmutable();
}
