/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.map.primitive;

import org.eclipse.collections.api.IntIterable;
import org.eclipse.collections.api.block.function.primitive.ByteToObjectFunction;
import org.eclipse.collections.api.block.predicate.primitive.BytePredicate;
import org.eclipse.collections.api.block.predicate.primitive.IntBytePredicate;
import org.eclipse.collections.api.collection.ImmutableCollection;
import org.eclipse.collections.api.collection.primitive.ImmutableByteCollection;

/**
 * This file was automatically generated from template file immutablePrimitivePrimitiveMap.stg.
 *
 * @since 3.0.
 */
public interface ImmutableIntByteMap extends IntByteMap
{
    ImmutableIntByteMap select(IntBytePredicate predicate);

    ImmutableIntByteMap reject(IntBytePredicate predicate);

    ImmutableByteCollection select(BytePredicate predicate);

    ImmutableByteCollection reject(BytePredicate predicate);

    <V> ImmutableCollection<V> collect(ByteToObjectFunction<? extends V> function);

    ImmutableIntByteMap newWithKeyValue(int key, byte value);

    ImmutableIntByteMap newWithoutKey(int key);

    ImmutableIntByteMap newWithoutAllKeys(IntIterable keys);
}
