/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.stack.primitive;

import org.eclipse.collections.api.block.function.primitive.IntToObjectFunction;
import org.eclipse.collections.api.block.predicate.primitive.IntPredicate;
import org.eclipse.collections.api.list.primitive.IntList;
import org.eclipse.collections.api.stack.MutableStack;

/**
 * This file was automatically generated from template file mutablePrimitiveStack.stg.
 *
 * @since 3.0.
 */
public interface MutableIntStack extends IntStack
{
    /**
     * Adds an item to the top of the stack.
     */
    void push(int item);

    /**
     * Removes and returns the top element of the stack.
     */
    int pop();

    /**
     * Removes and returns a IntList of the number of elements specified by the count, beginning with the top of the stack.
     */
    IntList pop(int count);

    /**
     * Clears the Stack
     */
    void clear();

    MutableIntStack select(IntPredicate predicate);

    MutableIntStack reject(IntPredicate predicate);

    <V> MutableStack<V> collect(IntToObjectFunction<? extends V> function);

    MutableIntStack asUnmodifiable();

    MutableIntStack asSynchronized();
}
