/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.stack.primitive;

import org.eclipse.collections.api.block.function.primitive.ShortToObjectFunction;
import org.eclipse.collections.api.block.predicate.primitive.ShortPredicate;
import org.eclipse.collections.api.list.primitive.ShortList;
import org.eclipse.collections.api.stack.MutableStack;

/**
 * This file was automatically generated from template file mutablePrimitiveStack.stg.
 *
 * @since 3.0.
 */
public interface MutableShortStack extends ShortStack
{
    /**
     * Adds an item to the top of the stack.
     */
    void push(short item);

    /**
     * Removes and returns the top element of the stack.
     */
    short pop();

    /**
     * Removes and returns a ShortList of the number of elements specified by the count, beginning with the top of the stack.
     */
    ShortList pop(int count);

    /**
     * Clears the Stack
     */
    void clear();

    MutableShortStack select(ShortPredicate predicate);

    MutableShortStack reject(ShortPredicate predicate);

    <V> MutableStack<V> collect(ShortToObjectFunction<? extends V> function);

    MutableShortStack asUnmodifiable();

    MutableShortStack asSynchronized();
}
