/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.impl.lazy.primitive;

import java.util.Iterator;

import org.eclipse.collections.api.IntIterable;
import org.eclipse.collections.api.block.function.primitive.IntToBooleanFunction;
import org.eclipse.collections.api.block.procedure.primitive.IntProcedure;
import org.eclipse.collections.api.block.procedure.primitive.BooleanProcedure;
import org.eclipse.collections.api.iterator.IntIterator;
import org.eclipse.collections.api.iterator.BooleanIterator;

/**
 * This file was automatically generated from template file collectPrimitiveToPrimitiveIterable.stg.
 */
public class CollectIntToBooleanIterable
        extends AbstractLazyBooleanIterable
{
    private final IntIterable iterable;
    private final IntToBooleanFunction function;

    public CollectIntToBooleanIterable(IntIterable iterable, IntToBooleanFunction function)
    {
        this.iterable = iterable;
        this.function = function;
    }

    public void each(final BooleanProcedure procedure)
    {
        this.iterable.forEach(new IntProcedure()
        {
            public void value(int each)
            {
                procedure.value(CollectIntToBooleanIterable.this.function.valueOf(each));
            }
        });
    }

    public BooleanIterator booleanIterator()
    {
        return new BooleanIterator()
        {
            private final IntIterator iterator = CollectIntToBooleanIterable.this.iterable.intIterator();

            public boolean hasNext()
            {
                return this.iterator.hasNext();
            }

            public boolean next()
            {
                return CollectIntToBooleanIterable.this.function.valueOf(this.iterator.next());
            }
        };
    }

    @Override
    public int size()
    {
        return this.iterable.size();
    }

    @Override
    public boolean isEmpty()
    {
        return this.iterable.isEmpty();
    }

    @Override
    public boolean notEmpty()
    {
        return this.iterable.notEmpty();
    }
}
