/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.impl.lazy.primitive;

import java.util.Iterator;

import org.eclipse.collections.api.IntIterable;
import org.eclipse.collections.api.block.function.primitive.IntToLongFunction;
import org.eclipse.collections.api.block.procedure.primitive.IntProcedure;
import org.eclipse.collections.api.block.procedure.primitive.LongProcedure;
import org.eclipse.collections.api.iterator.IntIterator;
import org.eclipse.collections.api.iterator.LongIterator;

/**
 * This file was automatically generated from template file collectPrimitiveToPrimitiveIterable.stg.
 */
public class CollectIntToLongIterable
        extends AbstractLazyLongIterable
{
    private final IntIterable iterable;
    private final IntToLongFunction function;

    public CollectIntToLongIterable(IntIterable iterable, IntToLongFunction function)
    {
        this.iterable = iterable;
        this.function = function;
    }

    public void each(final LongProcedure procedure)
    {
        this.iterable.forEach(new IntProcedure()
        {
            public void value(int each)
            {
                procedure.value(CollectIntToLongIterable.this.function.valueOf(each));
            }
        });
    }

    public LongIterator longIterator()
    {
        return new LongIterator()
        {
            private final IntIterator iterator = CollectIntToLongIterable.this.iterable.intIterator();

            public boolean hasNext()
            {
                return this.iterator.hasNext();
            }

            public long next()
            {
                return CollectIntToLongIterable.this.function.valueOf(this.iterator.next());
            }
        };
    }

    @Override
    public int size()
    {
        return this.iterable.size();
    }

    @Override
    public boolean isEmpty()
    {
        return this.iterable.isEmpty();
    }

    @Override
    public boolean notEmpty()
    {
        return this.iterable.notEmpty();
    }
}
