/*
 * Copyright (c) 2015 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.impl.set.mutable.primitive;

import org.eclipse.collections.api.LongIterable;
import org.eclipse.collections.api.factory.set.primitive.MutableLongSetFactory;
import org.eclipse.collections.api.set.primitive.MutableLongSet;

/**
 * MutableLongSetFactoryImpl is a factory implementation which creates instances of type {@link MutableLongSet}.
 * This file was automatically generated from template file mutablePrimitiveSetFactoryImpl.stg.
 *
 * @since 6.0.
 */
public class MutableLongSetFactoryImpl implements MutableLongSetFactory
{
    public MutableLongSet empty()
    {
        return new LongHashSet();
    }

    public MutableLongSet of()
    {
        return this.empty();
    }

    public MutableLongSet with()
    {
        return this.empty();
    }

    public MutableLongSet of(long... items)
    {
        return this.with(items);
    }

    public MutableLongSet with(long... items)
    {
        if (items == null || items.length == 0)
        {
            return this.empty();
        }
        return LongHashSet.newSetWith(items);
    }

    public MutableLongSet ofAll(LongIterable items)
    {
        return this.withAll(items);
    }

    public MutableLongSet withAll(LongIterable items)
    {
        return LongHashSet.newSet(items);
    }
}
